

//Render all the custom  buttons in Intellistatus.htm
function LoadIntelliButtons()
{



   var btn = new ActionButton();
   btn.Type = ACTION_BUTTON_CUSTOM;
   btn.Text = btLOC_ITS_CleanUp;
   btn.FloatClass = "floatR";
   btn.Width = btLOC_ITS_width;
   
   btn.Event = "external.DoOnHardDriveSectionActionButtonClick();";
   Get("spHardDriveCleanUpButton").innerHTML = btn.Render();
   
   btn.Event = "external.DoOnSystemMemorySectionActionButtonClick();";
   btn.Text = btLOC_ITS_Optimize;
   Get("spMemoryCleanUpButton").innerHTML = btn.Render();
   
   btn.Text = btLOC_ITS_Configure;
   btn.Event = "external.DoOnStartupSectionActionButtonClick();";
   Get("spStartUpConfigureButton").innerHTML = btn.Render();
   
   btn.Text = btLOC_ITS_Configure;
   btn.Event = "external.DoOnRunningSectionActionButtonClick();";
   Get("spRunningConfigureButton").innerHTML = btn.Render();
   
   btn.Text = btLOC_ITS_Optimize;
   btn.Event = "external.DoOnInternetSectionActionButtonClick();";
   Get("spOptimizeButton").innerHTML = btn.Render();
   
   
   btn.Text = btLOC_ITS_MeasureNow;
   btn.Event = "external.DoOnInternetSectionRefreshButtonClick();";
   Get("spInternetSpeedMeasureNow").innerHTML = btn.Render();
   
   // Render Refresh buttons
   _SetHardDriveRefreshButtonEnable(true);
   _SetSystemMemoryRefreshButtonEnable(true);
   _SetStartupRefreshButtonEnable(true);
   _SetRunningRefreshButtonEnable(true);
   _SetInternetSpeedRefreshButtonEnable(true);
 
   
   SetInternetSpeedMeasured(false);
   
  
}

// Call it when page load
AddLoadEvent(LoadIntelliButtons);

//********************************** IntellistatusTable Class ********************************************

function IntellistatusTable(id)
{
  this.ID = id;
  this.tbl = new Table(id);
  this.tbl.Width = "100%";
  this.tbl.Class = "tb_spaces";
  this.tbl.Border = "0";
  
  this.Render = __RenderIntellistatusTable;
  this.Add = __AddIntellistatusTable;
  
  function __RenderIntellistatusTable()
  {
    return this.tbl.Render();
  }
  
  function __AddIntellistatusTable(Column1, Column2, Column3)
  {
     var tr = new TR();
     
     var td1 = new TD();
     td1.Data = Column1;
     td1.Align = "left";
     tr.Add(td1);
     
     var td2 = new TD();
     td2.Data = Column2;
     td2.Align = "right";
     tr.Add(td2);
     
     var td3 = new TD();
     td3.Data = Column3;
     td3.Align = "right";
     td3.Width = "125px"
     tr.Add(td3);
     
     this.tbl.Add(tr);
  }
  
}
//********************************** End IntellistatusTable Class ********************************************


//********************************** UI Functions ********************************************

function SetHardDriveTotal(Value)
{
   Get("spHardDriveTotalFreeSpace").innerHTML =  URLDecode(Value);
}
function SetSystemMemoryTotal(Value)
{
   Get("spTotalSystemMemory").innerHTML =  URLDecode(Value);
}

function AddHardDriveRow(DriveName, FreeSpave, Capacity)
{
   var hd = new IntellistatusTable("hd");
   var drive = "<img src=\"ITS_icon_harddrive.gif\"   /><b>&nbsp;" +  URLDecode(DriveName) + "</b>";
   
   hd.Add( drive,  URLDecode(FreeSpave) ,  URLDecode(Capacity));
   
   if(!hd.tbl.IsRendered())
     Get("divHardDrives").innerHTML = hd.Render();
     
   hd.tbl.ChangeClassInRowByIndex(0, "toprow");
}

function ClearHardDriveRows()
{
    Get("divHardDrives").innerHTML = "";
}


function SetHardDriveTotalRowValues(FreeSpace, Capacity)
{
   Get("spHardDriveFreeSpace").innerHTML =  URLDecode(FreeSpace);
   Get("spHardDriveTotalCapacity").innerHTML =  URLDecode(Capacity);
}

// Value: int
function SetHardDriveGraphPosition(Value)
{
  var p = new ProgressBar();
  p.ID = "HardDrive";
  p.Width = "335";
  p.Progress = Value;
  if(!p.IsRendered())
    Get('divHardDriveProgressBar').innerHTML = p.Render();
  else
    p.SetProgress(Value); 
}

// Value : stirng
function SetHardDriveGraphLabel(Value)
{
  var p = new ProgressBar();
  p.ID = "HardDrive";
  p.SetProgressGraphLabel(URLDecode( Value));
}


// Value: int
function SetSystemMemoryGraphPosition(Value)
{
  var p = new ProgressBar();
  p.ID = "Memory";
  p.Width = "335";
  p.Progress = Value;
  if(!p.IsRendered())
    Get('divMemoryProgressBar').innerHTML = p.Render();
  else
    p.SetProgress(Value); 
}

// Value : stirng
function SetSystemMemoryGraphLabel(Value)
{
  var p = new ProgressBar();
  p.ID = "Memory";
  p.SetProgressGraphLabel( URLDecode(Value));
}




function SetSystemMemoryCounts(PhysicalCol1, PhysicalCol2, PageFileCol1, PageFileCol2, VirtualCol1, VirtualCol2)
{
   Get('spPhysicalCol1').innerHTML =  URLDecode(PhysicalCol1);
   Get('spPhysicalCol2').innerHTML =  URLDecode(PhysicalCol2);
   
   Get('spPageFileCol1').innerHTML =  URLDecode(PageFileCol1);
   Get('spPageFileCol2').innerHTML =  URLDecode(PageFileCol2);
   
   Get('spVirtualCol1').innerHTML =  URLDecode(VirtualCol1);
   Get('spVirtualCol2').innerHTML =  URLDecode(VirtualCol2);
   
}   

function SetStartupCounts(Total, Dangerous, Unknown, Optional, Necessary, System)
{
   Get('spStartupTotal').innerHTML =  URLDecode(Total);
   Get('spStartupDangerous').innerHTML = URLDecode( Dangerous);
   
   Get('spStartupUnknown').innerHTML =  URLDecode(Unknown);
   Get('spStartupOptional').innerHTML =  URLDecode(Optional);
   
   Get('spStartupNecessary').innerHTML =  URLDecode(Necessary);
   Get('spStartupSystem').innerHTML =  URLDecode(System);
}



function SetRunningCounts(Total, Dangerous, Unknown, Optional, Necessary, System)
{
   Get('spRunningTotal').innerHTML =  URLDecode(Total);
   Get('spRunningDangerous').innerHTML =  URLDecode(Dangerous);
   
   Get('spRunningUnknown').innerHTML =  URLDecode(Unknown);
   Get('spRunningOptional').innerHTML =  URLDecode(Optional);
   
   Get('spRunningNecessary').innerHTML =  URLDecode(Necessary);
   Get('spRunningSystem').innerHTML =  URLDecode(System);
}




function SetInternetDownloadSpeed(Value)
{
  Get('spInternetSpeed').innerHTML =  URLDecode(Value);
}

// Value : stirng
function SetInternetDownloadGraphLabel(Value)
{
  var p = new ProgressBar();
  p.ID = "InternetDownLoad";
  p.SetProgressGraphLabel( URLDecode(Value));
}

// Value: int
function SetInternetDownloadGraphPosition(Value)
{
  var p = new ProgressBar();
  p.ID = "InternetDownLoad";
  p.Width = "296";
  p.Progress = Value;
  if(!p.IsRendered())
    Get('divInternetDownLoad').innerHTML = p.Render();
  else
    p.SetProgress(Value); 
    
  p = new IntelliInternetSpeedBar();
  if(!p.IsRendered())
    Get('divInternetSpeed').innerHTML = p.Render();
  p.SetProgress(Value); 
}                         


 
function SetInternetDownloadGraphRange(Value)
{
  var  obj = new IntelliInternetSpeedBarProperties();
  obj.Get(Value); 
  
  var p = new IntelliInternetSpeedBar();
  if(!p.IsRendered())
    Get('divInternetSpeed').innerHTML = p.Render();
  p.SetRange(obj); 
  
  Get('spInternetSpeedLeft').innerHTML = obj.LowRange;
  Get('spInternetSpeedRight').innerHTML = obj.HighRange;
    
}

var InternetSectionLoading = false;


function SetInternetSectionBusy(Value)
{
  //SetVisibility("tblInternetSpeed", !Value);
  SetDisplayWidget("tblInternetSpeed", !Value);
  
  SetDisplayWidget("tblInternetSpeedLoading", Value);
  SetDisplayWidget("tblInternetSpeedMeasureNow", false);
  _SetInternetSpeedRefreshButtonEnable(!Value);
  
  InternetSectionLoading = Value;
}   

function SetInternetSpeedMeasured(Value)
{
   SetDisplayWidget("tblInternetSpeedMeasureNow", !Value);
   
   
   if(!Value)
   {
       //SetVisibility("tblInternetSpeed", true);
       SetDisplayWidget("tblInternetSpeed", false);
       SetDisplayWidget("tblInternetSpeedLoading", false);
       
   _SetInternetSpeedRefreshButtonEnable(false);
       
   }else
   {
     SetInternetSectionBusy(InternetSectionLoading);
   }
}


// Value : bool
function SetHardDriveSectionBusy(Value)
{
 SetVisibility("tblHardDrive", !Value);
 SetDisplayWidget("tblHardDriveLoading", Value);
 _SetHardDriveRefreshButtonEnable(!Value);
}

// Value : bool
function SetSystemMemorySectionBusy(Value)
{
  SetVisibility("tblSystemMemory", !Value);
  SetDisplayWidget("tblSystemMemoryLoading", Value);
  _SetSystemMemoryRefreshButtonEnable(!Value);
}

// Value : bool
function SetStartupSectionBusy(Value)
{
  SetVisibility("tblStartup", !Value);
  SetDisplayWidget("tblStartupLoading", Value);
  _SetStartupRefreshButtonEnable(!Value);
}

// Value : bool
function SetRunningSectionBusy(Value)
{
  SetVisibility("tblRunning", !Value);
  SetDisplayWidget("tblRunningLoading", Value);
  _SetRunningRefreshButtonEnable(!Value);
}   



//********************************** End UI Functions ********************************************

//*********************************** Internal Fuctions ******************************************

// value : bool
function _SetHardDriveRefreshButtonEnable(value)
{
   var btn = new ActionButton();
   btn.Type = ACTION_BUTTON_IMAGE;
   if(value)
   {
     btn.Event = "external.DoOnHardDriveSectionRefreshButtonClick();";
     btn.Class = "hand";
     btn.Image = "ITS_bt_refresh.gif";
     btn.ImageHover = "ITS_bt_refresh_hover.gif";
   }else
   {
     btn.Image = "ITS_bt_refresh_disabled.gif";
   }
   Get("spHardDriveRefresh").innerHTML = btn.Render();
}

// value : bool
function _SetSystemMemoryRefreshButtonEnable(value)
{
   var btn = new ActionButton();
   btn.Type = ACTION_BUTTON_IMAGE;
   if(value)
   {
     btn.Event = "external.DoOnSystemMemorySectionRefreshButtonClick();";
     btn.Class = "hand";
     btn.Image = "ITS_bt_refresh.gif";
     btn.ImageHover = "ITS_bt_refresh_hover.gif";
   }else
   {
     btn.Image = "ITS_bt_refresh_disabled.gif";
   }
   Get("spSystemMemoryRefresh").innerHTML = btn.Render();
}

// value : bool
function _SetStartupRefreshButtonEnable(value)
{
   var btn = new ActionButton();
   btn.Type = ACTION_BUTTON_IMAGE;
   if(value)
   {
     btn.Event = "external.DoOnStartupSectionRefreshButtonClick();";
     btn.Class = "hand";
     btn.Image = "ITS_bt_refresh.gif";
     btn.ImageHover = "ITS_bt_refresh_hover.gif";
   }else
   {
     btn.Image = "ITS_bt_refresh_disabled.gif";
   }
   Get("spStartupRefresh").innerHTML = btn.Render();
}

// value : bool
function _SetRunningRefreshButtonEnable(value)
{
   var btn = new ActionButton();
   btn.Type = ACTION_BUTTON_IMAGE;
   if(value)
   {
     btn.Event = "external.DoOnRunningSectionRefreshButtonClick();";
     btn.Class = "hand";
     btn.Image = "ITS_bt_refresh.gif";
     btn.ImageHover = "ITS_bt_refresh_hover.gif";
   }else
   {
     btn.Image = "ITS_bt_refresh_disabled.gif";
   }
   Get("spRunningRefresh").innerHTML = btn.Render();
}

// value : bool
function _SetInternetSpeedRefreshButtonEnable(value)
{
   var btn = new ActionButton();
   btn.Type = ACTION_BUTTON_IMAGE;
   if(value)
   {
     btn.Event = "external.DoOnInternetSectionRefreshButtonClick();";
     btn.Class = "hand";
     btn.Image = "ITS_bt_refresh.gif";
     btn.ImageHover = "ITS_bt_refresh_hover.gif";
   }else
   {
     btn.Image = "ITS_bt_refresh_disabled.gif";
   }
   Get("spInternetSpeedRefresh").innerHTML = btn.Render();
}

//*********************************** End Internal Fuctions ******************************************


//**************************** ToolTip Functions **********************************


var Intelli_Dangerous = "0";
var Intelli_Unknown = "1";
var Intelli_Optional = "2";
var Intelli_Necessary = "3";
var Intelli_System = "4";


var arrIntelliStartupToolTips = new Array("divStartupDangerousContent","divStartupUnknownContent"
,"divStartupOptionalTabContent","divStartupNecessaryTabContent","divStartupSystemContent");

var arrIntelliRunningToolTips = new Array("divRunningDangerousTabContent","divRunningUnknownTabContent"
,"divRunningOptionalTabContent","divRunningNecessaryTabContent","divRunningSystemTabContent");


function ClearRunningProgramNames(CategoryID)
{
   var id = arrIntelliRunningToolTips[parseInt(CategoryID)] ;
   Get(id).getElementsByTagName("DIV")[0].innerHTML = "";
}
function ClearStartupProgramNames(CategoryID)
{
   var id = arrIntelliStartupToolTips[parseInt(CategoryID)] ;
   Get(id).getElementsByTagName("DIV")[0].innerHTML = "";
}

function AddRunningProgramName(CategoryID , ProgramName)
{
  var id = arrIntelliRunningToolTips[parseInt(CategoryID)] ;
  Get(id).getElementsByTagName("DIV")[0].innerHTML +=  "<li>" +  URLDecode(ProgramName) + "</li>";
}


function AddStartupProgramName(CategoryID , ProgramName)
{
   var id = arrIntelliStartupToolTips[parseInt(CategoryID)] ;
   Get(id).getElementsByTagName("DIV")[0].innerHTML +=  "<li>" +  URLDecode(ProgramName) + "</li>";
}

function SetRunningProgramLinkText(CategoryID,LinkText)
{
    var id = arrIntelliRunningToolTips[parseInt(CategoryID)] ;
   Get(id).getElementsByTagName("DIV")[1].getElementsByTagName("A")[0].innerHTML = URLDecode(LinkText) 
}
function SetStartupProgramLinkText(CategoryID,LinkText)
{
   var id = arrIntelliStartupToolTips[parseInt(CategoryID)] ;
   Get(id).getElementsByTagName("DIV")[1].getElementsByTagName("A")[0].innerHTML = URLDecode(LinkText)  
}






//**************************** End  ToolTip Functions **********************************

//*********************************** Set Language *************************//
function SetLanguage (language)
{
   	 Get("spLOC_HardDriveSpace").innerHTML = spLOC_HardDriveSpace;
	 Get("spLOC_SystemMemory").innerHTML = spLOC_SystemMemory;
	 Get("spLOC_StartupPrograms").innerHTML = spLOC_StartupPrograms;
	 Get("spLOC_RunningPrograms").innerHTML = spLOC_RunningPrograms;
	 Get("spLOC_InternetSpeed").innerHTML = spLOC_InternetSpeed;
 	 Get("spLOC_TotalFree").innerHTML = spLOC_TotalFree;
	 Get("spLOC_FreeSystemMemory").innerHTML=spLOC_FreeSystemMemory;
	 Get("spLOC_TotalStartupPrograms").innerHTML=spLOC_TotalStartupPrograms;
	 Get("spLOC_TotalRunningPrograms").innerHTML=spLOC_TotalRunningPrograms;
	 Get("spLOC_DownloadSpeed").innerHTML=spLOC_DownloadSpeed;
	 Get("spLOC_DownloadSpeed2").innerHTML=spLOC_DownloadSpeed;
	 Get("spLOC_FreeSpace").innerHTML=spLOC_FreeSpace;
	 Get("spLOC_TotalCapacity").innerHTML=spLOC_TotalCapacity;
	 Get("spLOC_ITS_Total").innerHTML=spLOC_ITS_Total;
	 Get("spLOC_FreeMemory").innerHTML=spLOC_FreeMemory;
	 Get("spLOC_TotalMemory").innerHTML=spLOC_TotalMemory;
	 Get("spLOC_Physical").innerHTML=spLOC_Physical;
	 Get("spLOC_PageFile").innerHTML=spLOC_PageFile;
	 Get("spLOC_Virtual").innerHTML=spLOC_Virtual;
	 Get("pLOC_ITS_Loading").innerHTML=pLOC_ITS_Loading;
	 Get("pLOC_ITS_Loading2").innerHTML=pLOC_ITS_Loading;
	 Get("pLOC_ITS_Loading3").innerHTML=pLOC_ITS_Loading;
	 Get("pLOC_ITS_Loading4").innerHTML=pLOC_ITS_Loading;
	 Get("pLOC_ITS_Loading5").innerHTML=pLOC_ITS_Loading;
	 Get("spLOC_ITS_Dangerous").innerHTML=spLOC_ITS_Dangerous;
	 Get("spLOC_ITS_Necessary").innerHTML=spLOC_ITS_Necessary;
	 Get("spLOC_ITS_Unknown").innerHTML=spLOC_ITS_Unknown;
	 Get("spLOC_ITS_System").innerHTML=spLOC_ITS_System;
	 Get("spLOC_ITS_Optional").innerHTML=spLOC_ITS_Optional;
	 Get("spLOC_ITS_Dangerous2").innerHTML=spLOC_ITS_Dangerous;
	 Get("spLOC_ITS_Necessary2").innerHTML=spLOC_ITS_Necessary;
	 Get("spLOC_ITS_Unknown2").innerHTML=spLOC_ITS_Unknown;
	 Get("spLOC_ITS_System2").innerHTML=spLOC_ITS_System;
	 Get("spLOC_ITS_Optional2").innerHTML=spLOC_ITS_Optional;

}


//**************************** End Set Language **********************************


function intelli1()
{
//ClearStartupProgramNames("0");

AddStartupProgramName("0","sdfsdfdsfsdfsdf");
AddStartupProgramName("1","XX");
AddStartupProgramName("2","CC");
AddStartupProgramName("3","HH");
AddStartupProgramName("4","TTTTTTTTT");



AddRunningProgramName("0","sdfsdfdsfsdfsdf");
AddRunningProgramName("1","XX");
AddRunningProgramName("2","CC");
AddRunningProgramName("3","HH");
AddRunningProgramName("4","TTTTTTTTT");

SetStartupProgramLinkText("0","LinkExtention");
SetRunningProgramLinkText("0","LinkExtention");


//AddStartupProgramName("0","______");


//ClearHardDriveRows();

//GrayOut(true);

  //SetHardDriveSectionBusy(true);
//  SetSystemMemorySectionBusy(true);
//  SetStartupSectionBusy(true);
//  
 // SetInternetSectionBusy(true);
 // SetRunningSectionBusy(true);
// 
//  AddStartupProgramName(Intelli_System, "XXXXXXXVV");
//  AddStartupProgramName("0", "00000");

//  AddStartupProgramName("1", "1111");

//  AddStartupProgramName("2", "2222");
//  AddStartupProgramName("3", "3333");
//  AddStartupProgramName("4", "44444");
//   AddStartupProgramName("0", "-0000");

//  AddStartupProgramName("1", "111");

//  AddStartupProgramName("2", "22");
//  AddStartupProgramName("3", "3e333");
//  AddStartupProgramName("4", "454444");
//  AddRunningProgramName("4","QQQQQQQQQ");
//  
//  
//  SetStartupProgramLinkText('4',"?ZZZZZZZZZZZZ");
// 
  
}

function intelli2()
{
ClearStartupProgramNames("0");

ClearStartupProgramNames("4");
ClearStartupProgramNames("0");


SetInternetDownloadGraphRange(0);

SetInternetDownloadGraphPosition(1);

SetHardDriveTotal("hdtotal");
SetSystemMemoryTotal("mm Total");
AddHardDriveRow("X", "23", "23");
SetHardDriveTotalRowValues("dd", "cc");
SetHardDriveGraphPosition(89);
SetHardDriveGraphLabel("89  free");
SetSystemMemoryCounts("s", "s", "d", "d", "v", "v");
SetRunningCounts("tot", "d", "u", "o", "n", "s");
SetStartupCounts("tot", "d", "u", "o", "n", "s");
SetInternetDownloadSpeed("SSS");
SetInternetDownloadGraphLabel("89 ");
SetSystemMemoryGraphPosition(78);
SetSystemMemoryGraphLabel("78");

  SetHardDriveSectionBusy(false);
  SetSystemMemorySectionBusy(false);
  SetStartupSectionBusy(false);
  SetInternetSectionBusy(false);
  SetRunningSectionBusy(false);
  
 
  
  
  
  
  
}

function intelli3()
{
 SetInternetSpeedMeasured(true);
} 

function intelli4()
{

 SetInternetSpeedMeasured(false);
}

function intelli5()
{
//SetInternetSpeedMeasured(false)

//SetInternetSectionBusy(true)

SetInternetSpeedMeasured(true)

//SetInternetSectionBusy(false)

//SetInternetDownloadGraphRange("5")

//SetInternetDownloadGraphPosition("44")

//SetInternetDownloadSpeed("4.34+Mbps")

//SetInternetDownloadGraphLabel("4.34+M")

}


